Arch Space
|
Menu location |
---|
Arch → Space |
Workbenches |
Arch |
Default shortcut |
S P |
Introduced in version |
0.14 |
See also |
Arch Wall, Arch Structure |
Description
The Space tool allows you to define an empty volume, either by basing it on a solid shape, or by defining its boundaries, or a mix of both. If it is based solely on boundaries, the volume is calculated by starting from the bounding box of all the given boundaries, and subtracting the spaces behind each boundary. The space object always defines a solid volume. The floor area of a space object, calculated by intersecting a horizontal plane at the center of mass of the space volume, can also be displayed.
Space object created from an existing solid object, then two wall faces are added as boundaries.
Usage
- Select an existing solid object, or faces on boundary objects.
- Invoke the Arch Space command using several methods:
- Pressing the
Arch Space button in the toolbar.
- Using the S then P keyboard keys
- Using the Arch → Space entry from the top menu
- Pressing the
Limitations
- The boundaries properties is currently not editable via GUI.
- See the forum announcement.
Properties
- DataBase: The base object, if any (must be a solid)
- DataBoundaries: A list of optional boundary elements
- DataArea: The computed floor area of this space
- DataFinishFloor: The finishing of the floor of this space
- DataFinishWalls: The finishing of the walls of this space
- DataFinishCeiling: The finishing of the ceiling of this space
- DataGroup: Objects that are included inside this space, such as furniture
- DataSpaceType: The type of this space
- DataFloorThickness: The thickness of the floor finish
- DataNumberOfPeople: The number of people who typically occupy this space
- DataLightingPower: The electric power needed to light this space in Watts
- DataEquipmentPower: The electric power needed by the equipment of this space in Watts
- DataAutoPower: If True, Equipment Power will be automatically filled by the equipment included in this space
- DataConditioning: The type of air conditioning of this space
- DataInternal: Specifies if this space is internal or external
- ViewText: The text to show. Use $area, $label, $tag, $floor, $walls, $ceiling to insert the respective data
- ViewFontName: The name of the font
- ViewTextColor: The color of the text
- ViewFontSize: The size of the text
- ViewFirstLine: The size of the first line of text (multiplies the font size. 1 = same size, 2 = double size, etc..)
- ViewLineSpacing: The space between the lines of text
- ViewTextPosition: The position of the text. Leave (0,0,0) for automatic position
- ViewTextAlign: The justification of the text
- ViewDecimals: The number of decimals to use for calculated texts
- ViewShowUnit: Show the unit suffix or not
Options
- To create zones that group several spaces, use a Arch BuildingPart and set its IFC type to "Spatial Zone"
- The space object has the same display modes as other Arch and Part objects, with one more, called Footprint, that displays only the bottom face of the space.
Scripting
See also: Arch API and FreeCAD Scripting Basics.
The Space tool can be used in macros and from the Python console by using the following function:
Space = makeSpace(objects=None, baseobj=None, name="Space")
- Creates a
Space
object from the givenobjects
orbaseobj
, which can be- one document object, in which case it becomes the base shape of the space object, or
- a list of selection objects as returned by
FreeCADGui.Selection.getSelectionEx()
, or - a list of tuples
(object, subobjectname)
Example:
import FreeCAD, Arch
Box = FreeCAD.ActiveDocument.addObject("Part::Box", "Box")
Box.Length = 1000
Box.Width = 1000
Box.Height = 1000
Space = Arch.makeSpace(Box)
Space.ViewObject.LineWidth = 2
FreeCAD.ActiveDocument.recompute()
After a space object is created, selected faces can be added to it with the following code:
import FreeCAD, FreeCADGui, Draft, Arch
points = [FreeCAD.Vector(-500, 0, 0), FreeCAD.Vector(1000, 1000, 0)]
Line = Draft.makeWire(points)
Wall = Arch.makeWall(Line, width=150, height=2000)
FreeCAD.ActiveDocument.recompute()
# Select a face of the wall
selection = FreeCADGui.Selection.getSelectionEx()
Arch.addSpaceBoundaries(Space, selection)
Boundaries can also be removed, again by selecting the indicated faces:
selection = FreeCADGui.Selection.getSelectionEx()
Arch.removeSpaceBoundaries(Space, selection)
- Elements: Wall, Structure, Curtain Wall, Window, Roof, Space, Stairs, Equipment, Frame, Fence, Truss, Profile, Pipe, Pipe Connector
- Reinforcements: Straight Rebar, U-Shape Rebar, L-Shape Rebar, Stirrup, Bent-Shape Rebar, Helical Rebar, Column Reinforcement, Beam Reinforcement, Slab Reinforcement, Footing Reinforcement, Custom Rebar
- Panels: Panel, Panel Cut, Panel Sheet, Nest
- Materials: Material, Multi-Material
- Organization: Building Part, Project, Site, Building, Level, External reference, Section Plane, Schedule
- Axes: Axis, Axes system, Grid
- Modification: Cut with plane, Cut with line, Add component, Remove component, Survey
- Utilities: Component, Clone component, Split Mesh, Mesh to Shape, Select non-manifold meshes, Remove Shape from Arch, Close Holes, Merge Walls, Check, Toggle IFC Brep flag, 3 Views from mesh, Create IFC spreadsheet, Toggle Subcomponents
- Additional: Preferences, Import Export Preferences (IFC, DAE, OBJ, JSON, 3DS, SHP), IfcOpenShell, IfcPlusPlus, Arch API

- Getting started
- Installation: Download, Windows, Linux, Mac, Additional components, Docker, AppImage, Ubuntu Snap
- Basics: About FreeCAD, Interface, Mouse navigation, Selection methods, Object name, Preferences, Workbenches, Document structure, Properties, Help FreeCAD, Donate
- Help: Tutorials, Video tutorials
- Workbenches: Std Base, Arch, Draft, FEM, Inspection, Mesh, OpenSCAD, Part, PartDesign, Path, Points, Reverse Engineering, Robot, Sketcher, Spreadsheet, Start, Surface, TechDraw, Test Framework, Web
- Hubs: User hub, Power users hub, Developer hub